.include "C:\PROGRA~1\vmlab\include\m8def.inc"

.def T1      = r1
.def T2      = r2
.def tmp1 = r10
;---------------------------------------------------;
.def tmp  = r16
.def max_mem = r17
.def max_memZ = r24
.def rmp = r18
.def enter = r19
.def Shut = r20
.def empty_again = r22
.equ UBRRVAL = 5

reset:
   rjmp start
   reti      ; Addr $01
   reti      ; Addr $02
   reti      ; Addr $03
   reti      ; Addr $04
   reti      ; Addr $05
   reti      ; Addr $06        Use 'rjmp myVector'
   reti      ; Addr $07        to define a interrupt vector
   reti      ; Addr $08
   rjmp timer0    ; Timer 0
   reti      ; Addr $0A
   reti      ; Addr $0B        This is just an example
   reti      ; Addr $0C        Not all MCUs have the same
   reti      ; Addr $0D        number of interrupt vectors
   reti 		 ;rjmp adc_action    ; ADC  ; Addr $0E
   reti      ; Addr $0F
   reti      ; Addr $10
   reti
   reti

; Program starts here after Reset

start:
	ldi r16, low(RAMEND)
   out SPL, r16
   ldi r16, high(RAMEND)
   out SPH, r16

		; USART Baudrat SETUP
  	ldi tmp, LOW(UBRRVAL)
	out UBRRL, tmp
	ldi tmp, HIGH(UBRRVAL)
	out UBRRH, tmp

	ldi tmp, (1<<URSEL)|(3<<UCSZ0)
	out UCSRC, tmp
	
   ldi tmp,0x01
	out TIMSK,tmp
	
	   ; Diod on DDB0 ON !!!! for power control
	ldi tmp,(1<<DDB0)
	out DDRB,tmp
	
	; Enable sleep mode, select falling edge
	ldi tmp, 0xA0
   out MCUCR,tmp
	
	ldi R19,0xD  ; Enter after each line.
	
	; Set up mem addr
	ldi XH,0x00
	ldi XL,0x00

	ldi ZH,0x00
	ldi ZL,0x00
	
   ; set max mem addr
	ldi max_mem,62

; RUN or not to RUN That is the question !!!
   ldi tmp,1<<PB5
   out PORTB,tmp
   ldi tmp,1<<DDD5
   out DDRD,tmp

   sbic PIND,5
   rcall yellow
   sbis PIND,5
   rcall green

   sbis PIND,5
   rcall wakeup2	

  	; Timer0 set-up and activation
   sbic PIND,5
	ldi tmp,(1<<CS01)
   sbic PIND,5
   out TCCR0,tmp ; Timer clock = system clock / 1024
   clr R20
   clr R10

   ; ADC activation
	ldi tmp,(1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADPS2)|(1<<ADPS1)
	out ADCSR,tmp
		
	; Shut delay flag
 	clr r22
	clr R21
   rcall longDelay
	sei	

forever:
rjmp forever

timer0:
in tmp,ADCL
in tmp1,ADCH

rcall write_too_mem1
rcall write_too_mem
cpse XL,max_mem
reti

push tmp
push tmp1
rcall test_high
pop tmp1
pop tmp
mov R20,tmp
rcall write_too_mem1
rcall write_too_mem

rcall MASTER_TX
adiw ZH:ZL ,63
mov r16, ZH

cpi r16, 0x32 ; Value must be 0x28
breq goto_sleep
;cpse ZL,max_memZ
reti

write_too_mem:
;---------------------------
EEPROM_write:
; Wait for completion of previous write
sbic EECR,EEWE
rjmp EEPROM_write
; Set up address  in address register
out EEARH, XH
out EEARL, XL
adiw XL,0x01
out EEDR,tmp
; Write logical one to EEMWE
sbi EECR,EEMWE
; Start eeprom write by setting EEWE
sbi EECR,EEWE
;---------------------------
ret

write_too_mem1:
;---------------------------
EEPROM_write1:
; Wait for completion of previous write
sbic EECR,EEWE
rjmp EEPROM_write1
; Set up address  in address register
out EEARH, XH
out EEARL, XL
adiw XL,0x01
out EEDR,tmp1
; Write logical one to EEMWE
sbi EECR,EEMWE
; Start eeprom write by setting EEWE
sbi EECR,EEWE
;---------------------------
ret

goto_sleep:

ldi tmp,1<<TCNT0
out TCNT0,tmp ;
ldi tmp,0b000
out TCCR0,tmp ; Timer clock = system clock / 1024
ldi tmp,0<<TOIE0
out TIMSK,tmp ; DISABLE Timer/Counter0 Overflow Interrupt

clr tmp
out ADCSR,tmp

cbi UCSRB,TXEN                    ; TX aktivieren
;Enable exeternal interrupts, that will wake up from sleep mode
ldi tmp, 0xC0
out GICR, tmp

clr tmp
out DDRB,tmp
cli
sleep
ret

wakeup:

ldi max_mem,64
rcall EEPROM_read
rcall fpconv10a
rcall UART_send

cpse XL,max_mem
rjmp wakeup
ret
reti

UART_send:
sbis UCSRA,UDRE
rjmp UART_send
out UDR,R5
UART_send2:
sbis UCSRA,UDRE
rjmp UART_send2
out UDR,R7
UART_send3:
sbis UCSRA,UDRE
rjmp UART_send3
out UDR,R8
UART_send4:
sbis UCSRA,UDRE
rjmp UART_send4
out UDR,R9
UART_send5:
sbis UCSRA,UDRE
rjmp UART_send5
out UDR,R19
ret

EEPROM_read:
; Wait for completion of previous write
sbic EECR,EEWE
rjmp EEPROM_read
out EEARH, XH
out EEARL, XL
; Start eeprom read by writing EERE
sbi EECR,EERE
; Read data from Data Register
in R2,EEDR
adiw XL,0x01

EEPROM_read1:
; Wait for completion of previous write
sbic EECR,EEWE
rjmp EEPROM_read1
out EEARH, XH
out EEARL, XL
; Start eeprom read by writing EERE
sbi EECR,EERE
; Read data from Data Register
in R1,EEDR
adiw XL,0x01

ret

fpconv10a:
	ldi rmp,HIGH(1000) ; Set the decimal divider value to 1,000
	mov R4,rmp
	ldi rmp,LOW(1000)
	mov R3,rmp
	rcall fpconv10d ; get ASCII digit by repeated subtraction
	mov R5,rmp ; set thousands string char
	clr R4 ; Set the decimal divider value to 100
	ldi rmp,100
	mov R3,rmp
	rcall fpconv10d ; get the next ASCII digit
	mov R7,rmp ; set hundreds string char
	ldi rmp,10 ; Set the decimal divider value to 10
    mov R3,rmp
	rcall fpconv10d ; get the next ASCII digit
	mov R8,rmp ; set tens string char
	ldi rmp,'0' ; convert the rest to an ASCII char
	add rmp,R1
	mov R9,rmp ; set ones string char
	ret

fpconv10d:
	ldi rmp,'0' ; start with decimal value 0
fpconv10d1:
	cp R1,R3 ; Compare word with decimal divider value
	cpc R2,R4
	brcc fpconv10d2 ; Carry clear, subtract divider value
	ret ; done subtraction
fpconv10d2:
	sub R1,R3 ; subtract divider value
	sbc R2,R4
	inc rmp ; up one digit
	rjmp fpconv10d1 ; once again

green:
ldi tmp,(1<<DDB2)|(1<<DDB0)
out DDRB,tmp
ret

yellow:
ldi tmp,(1<<DDB1)|(1<<DDB0)
out DDRB,tmp
ret

test_high:
rcall minus1
rcall shut1
ret

minus1:
cp R20,tmp
brmi minus
cpse R20,tmp
brpl plus
ret

minus:
inc R21
ret

plus:
clr R21
ret

shut1:

rcall off

cpi R21, 3
sbrs R22,0
breq shut

cpi R21, 5
sbrs R22,1
breq shut2
ret

shut:
ldi tmp,1<<DDC1
out DDRC,tmp

ser tmp
rcall write_too_mem1
rcall write_too_mem

rcall green
ldi R22,0x01
ret

shut2:

ldi tmp,1<<DDC2
out DDRC,tmp

ldi tmp,0xfe
rcall write_too_mem1
rcall write_too_mem

rcall green
ldi R22,0x02
ret

off:
ldi tmp,(0<<DDC1)|(0<<DDC2)
out DDRC,tmp
rcall yellow
ret

longDelay:
	clr   T1		;T1 used as delay 2nd count
	clr   T2		;T2 used as delay 3d count
delay_1:
	dec   T2
	brne  delay_1
	dec   T1
	brne  delay_1
	dec   tmp		;temp must be preset as
	brne  delay_1		; delay master count
ret



MASTER_TX:

   cli   ; Interrupts not used; must poll TWINT bit

; Set bitrate for master mode
; ---------------------------
   ldi r16, 10    ; Minimum value must be 10 !
   out TWBR, r16  ; See formula in Atmel manual

; Send start and wait for TWINT flag
; ----------------------------------
   ldi r16, (1<<TWINT) | (1<<TWSTA) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

; Load SLA + W and clear int flag
; -------------------------------
   ldi r16, 0xA0  ; Address = 0x1E, Write (TX)
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

;   in r16, TWSR
;   andi r16, 0xF8
;   cpi r16, 0x18 ; Status code must be 0x18
;   brne ERROR

;   in R16,TWSR
;   rcall write_too_mem

   mov r16, ZH
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

;   in R16,TWSR
;   rcall write_too_mem

   mov r16, ZL
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

;   in R16,TWSR
;   rcall write_too_mem
; Check TWI Status register
; -------------------------
   in r16, TWSR
   andi r16, 0xF8
   cpi r16, 0x28 ; Status code must be 0x18
  ; brne ERROR

   clr XL
   clr XH
   ldi r18, 0x40  ; Init byte to transmit
write_loop:

; Load data into TWDR register
; ----------------------------
   rcall EEPROM_read1
	out TWDR, r1
   ldi r16, (1<<TWINT)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint    ; Wait for completion

  ; in R16,TWSR
  ; rcall write_too_mem

; Check TWI Status register
; -------------------------
   in r16, TWSR
   andi r16, 0xF8
   cpi r16, 0x28 ; Value must be 0x28
 ;  brne ERROR

  dec r18          ; Decrement data for
  brne write_loop  ; next cycle

; Send STOP and return
; --------------------
   ldi r16, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)
   out TWCR, r16

adiw ZH:ZL,0x01
clr XL

ret

; *********************************************
; Error processing. TWI provides a status
; code, upon the completion of any operation
;
ERROR:
   ldi tmp,(1<<DDB0)
	out DDRB,tmp
   nop       ; Some error: not acknowledge, etc.
   nop       ; Process it here.
   nop       ;
   rjmp ERROR


; **********************************************
; Wait for TWI operation, by polling TWINT flag
;
wait_twint:
   in r16, TWCR
   sbrs r16, TWINT
   rjmp wait_twint
   ret

MASTER_RX:
   cli   ; Interrupts not used; must poll TWINT bit

; Set bitrate for master mode
; ---------------------------
   ldi r16, 10    ; Minimum value must be 10 !
   out TWBR, r16  ; See formula in Atmel manual

; Send start and wait for TWINT flag
; -----------------------------------
   ldi r16, (1<<TWINT)|(1<<TWSTA)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint
  ; in R16,TWSR
  ; rcall write_too_mem

; Load SLA + R  and clear int flag
; --------------------------------
   ldi r16, 0xA0 ; Slave address = 0x1D; 1 = Read (RX)
   out TWDR, r16
   ldi r16, (1<<TWINT)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   mov r16, ZH
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   mov r16, ZL
   out TWDR, r16
   ldi r16, (1<<TWINT) | (1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   ldi r16, (1<<TWINT)|(1<<TWSTA)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   ldi r16, 0xA1 ; Slave address = 0x1D; 1 = Read (RX)
   out TWDR, r16
   ldi r16, (1<<TWINT)|(1<<TWEN)
   out TWCR, r16
   rcall wait_twint

   ldi r16, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) ; Enable aknowledge
   out TWCR, r16
; Read loop for 7 bytes
; ---------------------


ldi r18, 0x40
read_loop:             ;
   rcall wait_twint    ; Wait for completion
   in r16, TWDR        ; Read received byte
;   clr r16
;   in R16,TWSR
   rcall write_too_mem

   ldi r16, (1<<TWINT)|(1<<TWEN)|(1<<TWEA) ; Enable aknowledge
   out TWCR, r16
   ;in R16,TWSR
   ;rcall write_too_mem
   dec r18
   ;adiw XL,0x01
   ;cpse ZH,max_memZ
   brne read_loop

   ldi r16, (1<<TWEN)  ; Disable aknowledge for last byte
   out TWCR, r16
   rcall wait_twint    ;

; Send STOP and return
; --------------------
   ldi r16, (1<<TWINT)|(1<<TWEN)|(1<<TWSTO)
   out TWCR, r16
   ret

wakeup2:
   sbi UCSRB,TXEN                    ; TX aktivieren
   clr XL
   clr XH
   rcall MASTER_RX
   clr XL
   clr XH
   rcall wakeup
   adiw ZH:ZL,1
   adiw ZH:ZL,63
   mov r16, ZH
   cpi r16, 0x32 ; Value must be 0x28
   breq goto_sleep2
   rjmp wakeup2
goto_sleep2:
rcall goto_sleep
ret



